ActiveAdmin.register Tour do
  menu  priority: 6,
        parent: I18n.t('activerecord.models.content_management'),
        if: proc{can?(:update, Tour)}
  # menu false

  index do
    selectable_column

    column :id
    column :name, :sortable => :name do |p|
      title = p.name if p.name.to_s.length < 40
      link_to(truncate(p.name, :length => 40), [:admin, p], title: "#{title || ""}" )
    end
    column :body, :sortable => :body do |p|
      text = strip_tags(p.body).to_s.strip
      content_tag(:span, truncate(text, :length => 40), title: text )
    end
    column :tag_list, :sortable => :tag_list do |p|
      best_in_place p, :tag_list, type: :input, path: [:admin, p]
    end

    # Options
    column :speed, :sortable => :speed do |p|
      best_in_place p, :speed, type: :input, :nil => "0", path: [:admin, p]
    end
    column :direction, :sortable => :direction do |p|
      best_in_place p, :direction, type: :select, path: [:admin, p],
            :collection => [["right"  , I18n.t(".right" ) ], ["left"   , I18n.t(".left"  ) ]]
                          # ["top"    , I18n.t(".top"   ) ], ["bottom" , I18n.t(".bottom") ],
    end
    column :control_display, :sortable => :control_display do |p|
      best_in_place p, :control_display, type: :checkbox, path: [:admin, p]
    end
    column :start_position, :sortable => :start_position do |p|
      best_in_place p, :start_position, type: :input, path: [:admin, p]
    end
    column :auto_start, :sortable => :auto_start do |p|
      best_in_place p, :auto_start, type: :checkbox, path: [:admin, p]
    end
    column :loop, :sortable => :loop do |p|
      best_in_place p, :loop, type: :checkbox, path: [:admin, p]
    end

    column :published, :sortable => :published do |p|
      best_in_place p, :published, type: :checkbox, path: [:admin, p]
    end
  end

  show do
    render :partial => "show", locals: { :s => tour }
  end

  form :partial => "form"

 batch_action :destroy, false
 config.clear_sidebar_sections!
end
