jQuery ->
  Tour_labels = window.Tour_labels ? ""

  $.fn.tour = (options) ->
    _id = 0
    _element = $()
    _viewPort = $()
    _panorama = $()
    _navBar   = $()
    # Traduções
    labels  = $.extend
      index: "Índice"
      rotate_left: "Rotacionar para esquerda"
      rotate_right: "Rotacionar para direita"
      play_stop: "Reproduzir/Parar"
      zoom: "Ampliar/Reduzir"
    , Tour_labels

    # Configurações
    _settings = $.extend
      viewport_width: 'auto'
      speed: 20000
      direction: "left"
      control_display: "auto"
      start_position: 0
      auto_start: false
      mode_360: true

      # Container dos botões da navegação
      navBarContainer: ".navbar:first > .navbar-inner > .container"

      # Placemment dos tooltips
      data_placement: "bottom"
    , options

    tour_animate = ->
      unless _panorama.length
        console.error "Não tem como animar um panorama que não existe :( !"
        return false

      currentPosition = 0 - parseInt(_panorama.css("margin-left"))

      if _settings.direction is "right"
        _panorama.animate marginLeft: 0 , ((_settings.speed / _settings.imageSizes["width"]) * (currentPosition)), "linear", ->
          if _settings.mode_360
            _panorama.css "marginLeft", "-#{parseInt(_settings.imageSizes["width"])}px"
            tour_animate()
      else
        rightlimit = if _settings.mode_360 then _settings.imageSizes["width"] else (_settings.imageSizes["width"] - _settings.viewport_width)

        _panorama.animate
          marginLeft: -rightlimit
        , ((_settings.speed / rightlimit) * (rightlimit - currentPosition)), "linear", ->
          if _settings.mode_360
            _panorama.css "margin-left", 0
            tour_animate()

    tour_toggle_stop = (element, action) ->
      $el   = $(element).stop()
      $btn  = $el.parent().find('.rtPlayBtn, .rtPauseBtn')

      if action is 'start'
        $btn.removeClass('rtPlayBtn').addClass('rtPauseBtn')
        tour_animate()
        $el.data('started', true)
      else
        $btn.removeClass('rtPauseBtn').addClass('rtPlayBtn')
        $el.data('started', false)

    _createNavBar= () ->

      _navBar = $(".BtnNavContainer", _settings.navBarContainer)
      _navBar = $("""<div class="BtnNavContainer"></div>""").appendTo(_settings.navBarContainer) unless _navBar.length

      navControllers = """
          <div class="dropdown fade dpIndex">
            <a class="BigButton btnIndex dropdown-toggle" data-toggle="dropdown" href="#" rel="tooltip" title="#{labels.index}" data-placement="#{_settings.data_placement}" ><span class="icon-list-4" aria-hidden="true"></span></a>
          </div>

          <div class="BigButton fade btnZoom" rel="tooltip" title="#{labels.zoom}" data-placement="#{_settings.data_placement}" ><span class="icon-zoom-in" aria-hidden="true"></span></div>

          <div class="barControls fade zoomedControllers">
            <div class="BigButton btnNext     " rel="tooltip" title="#{labels.rotate_left  }" data-placement="#{_settings.data_placement}" ><span class="icon-fast-backward " aria-hidden="true"></span></div>
            <div class="BigButton btnMove     " rel="tooltip" title="#{labels.play_stop    }" data-placement="#{_settings.data_placement}" ><span class="icon-play" aria-hidden="true"></span></div>
            <div class="BigButton btnPrevious " rel="tooltip" title="#{labels.rotate_right }" data-placement="#{_settings.data_placement}" ><span class="icon-fast-forward" aria-hidden="true"></span></div>
          </div>
        """

      navBigButtons = _navBar.append(navControllers).find(".BigButton")

      # Recarrega as core functions do twitter bootstrap
      $.loadBootstrap()

      if _settings.zoom
        btZoom = $(".btnZoom", _navBar)
          .addClass("in")
          .click ->
            if _t.zoom("value") is 1
              _t.zoom("zoomIn")
            else
              _t.zoom("zoomOut")

      btControls = $(".barControls", _navBar)
        .addClass("in")
        # Botão de play ou pausa
        .find(".btnMove")
          .click (e) ->
            e.preventDefault()
            span = $('span', this)
            if span.hasClass("icon-play")
              span.removeClass("icon-play").addClass("icon-pause")
              move("start")
            else
              span.removeClass("icon-pause").addClass("icon-play")
              move("stop")
        .end()
        # Botão para rotacioar para a esquerda
        .find(".btnPrevious")
          .mousedown (e) ->
            e.preventDefault()
            move("start", "left")
          .mouseup (e) ->
            e.preventDefault()
            move("stop")
        .end()
        # Botão para rotacionar para a direita
        .find(".btnNext")
          .mousedown (e) ->
            e.preventDefault()
            move("start", "right")
          .mouseup (e) ->
            e.preventDefault()
            move("stop")
        .end()

    # Faz a chamada na ação de avançar ou parar conforme a direção informada ou definida na configuração
    move = (action="start", direction) ->
      unless _panorama.length
        console.error "Não tem como mover um panorama que não existe :( !"
        return false

      _settings.direction = direction if direction

      # para o panorama caso ele ja esteja rotacionando e/ou caso a ação indique isso e altera o icone de pausa para play
      # Caso a ação indique para iniciar rotação, o panorama é iniciado e a variável data-started é definida como true
      btnMove = $(".btnMove span", _navBar)

      # Caso já iniciado para a animação
      if _panorama.data('started')
        stop()

      # Caso a ação seja iniciar, começa a animação
      if action is 'start'
        tour_animate()
        _panorama.data('started', true)
        btnMove.removeClass("icon-play").addClass("icon-pause")

    stop = () ->
      btnMoveSpan = $(".btnMove span", _navBar)
      _panorama.stop()
      _panorama.data('started', false)
      btnMoveSpan.removeClass("icon-pause").addClass("icon-play")

    rtRender = (element, panoramaViewport) ->
      _t = element

      _settings.imageSizes = {}
      $.each "naturalHeight naturalWidth".split(' '), (ix, val) ->
        _settings.imageSizes[val] = element[0][val]

      _settings.imageSizes["height"] = _settings.viewSize["height"]
      _settings.imageSizes["width"] = Math.round (_settings.imageSizes["height"] / _settings.imageSizes["naturalHeight"]) * _settings.imageSizes["naturalWidth"]

      element = element.addClass("markregion-image").wrap("""<div />""").parent()

      element
        .addClass("rtObject markregion")
        .attr("unselectable", "on")
        .css
          position: "relative"
          "-moz-user-select": "none"
          "-webkit-user-select": "none"
          margin: "0"
          padding: "0"
          border: "none"
          height: "#{_settings.imageSizes["height"]}px"
          width: "#{_settings.imageSizes["width"]}px"
        .wrap "<div class='rtContainer' />"
        # .wrap "<div class='rtContainer' style='width: #{_settings.imageSizes["width"]}px;'></div>"

      # carrega as marcações
      regions = element.markregion(
        path: _settings.path
        locale: _settings.locale
        editable: _settings.editable
        )

      element.on "markregion-create", (ev) ->
        element.clone().insertAfter element  if _settings.mode_360

      _panorama = element.parent()
        .css
          width: ((_settings.imageSizes["width"] * 2) + (_settings.imageSizes["width"] * 0.02))
          overflow: "hidden"
        # .append("<div class=\"overlay-block\"></div>")
        .appendTo(panoramaViewport)


      # Movimentação por click
      bMouseMove      = false
      mouseMoveStart  = 0

      # panoramaViewport
      _panorama
        .mousedown (e) ->
          unless bMouseMove
            bMouseMove = true
            mouseMoveStart = e.clientX
            $.mouseMoving = true
          false
        .mouseup ->
          bMouseMove = false
          mouseMoveStart = 0
          $.mouseMoving = false
          false
        .mousemove (e) ->
          if bMouseMove
            # console.debug "mousemove", e
            delta = parseInt((mouseMoveStart - e.clientX) / 30)
            # console.debug "delta", delta
            if (delta > 10) or (delta < 10)
              newMarginLeft = parseInt(_panorama.css("marginLeft")) - (delta)
              if _settings.mode_360
                newMarginLeft = -_settings.imageSizes["width"]  if newMarginLeft > 0
                newMarginLeft = 0  if newMarginLeft < -_settings.imageSizes["width"]
              else
                newMarginLeft = 0  if newMarginLeft > 0
                newMarginLeft = -_settings.imageSizes["width"]  if newMarginLeft < -_settings.imageSizes["width"]
              _panorama.css "marginLeft", newMarginLeft + "px"

      _panorama.css "margin-left": "-#{_settings.start_position}px"

      panoramaViewport.find('.rtOverlayContainer').hide ->
        $(this).remove()
      _createNavBar()

      move("start") if _settings.auto_start

    initAnnotate = (element) ->
      $(".annotate-image").annotateImage
        useAjax: false
        notes: [
          top: 286
          left: 161
          width: 30
          height: 30
          text: "Small people on the steps"
          id: "e69213d0-2eef-40fa-a04b-0ed998f9f1f5"
          editable: false
        ,
          top: 134
          left: 179
          width: 30
          height: 30
          text: "National Gallery Dome"
          id: "e7f44ac5-bcf2-412d-b440-6dbb8b19ffbe"
          editable: true
        ]


    @each ->
      _element = _t = $(this)

      $parent     = _t.parent().css('overflow', 'hidden')

      _settings.viewSize =
        height  : parseInt($parent.innerHeight() )
        width   : parseInt($parent.innerWidth()  )

      _settings.viewport_width = if _settings.viewport_width is 'auto' then _settings.viewSize.width else _settings.viewport_width

      _viewPort = panoramaViewport = $("<div />")
        .attr('id', "pan_#{_id++}")
        .addClass("requestTour rtViewport rtHor")
        .css
          width     : "#{_settings.viewport_width}px"
          height    : "#{_settings.viewSize.height}px"
          overflow  : "hidden"
        .appendTo($parent)

      # Loading
      loadingHtml = """
        <div class="rtOverlayContainer fade">
          <div class="rtOverlay"></div>
          <div class="rtLoading"></div>
        </div>
        """
      rtLoading = $(loadingHtml)
        .addClass('in')
        .appendTo(panoramaViewport)

      int = window.setInterval( ->
        if _t[0].complete
          clearInterval(int)
          rtRender(_t, panoramaViewport)
      , 100)
