###
@File : rd.markregion.js.coffee
@version : 0.5.0
@description : Cria marcação para tour virtual
@language : PT-BR Charset: UTF-8
@date : Sex Jul 19 14:54:00 AMT 2013

@package : RDCMS Tour

@author : Gullit Miranda <gullitmiranda@requestdev.com.br>

@copyright © RequestDev Sistemas 2011-2013, all right reserved.
http://www.requestdev.com.br
###

jQuery ->
  markregion =
    # Marcadores
    marcations: []

    # Configurações padrão
    defaults:
      editable: false
      resizable: false

      # Urls para ajax
      path: null

    init: (obj, options) ->
      self = @
      @element = obj

      @options = options = $.extend(true, {}, @defaults, options)

      # remove localização
      # @options.path = @options.path.replace(RegExp("^\/#{@options.locale}"), "") if @options.locale

      if (@element.get(0).tagName == "IMG" or !@element.hasClass("markregion"))
        @element = @element.wrap("<div class=\"markregion\" />").parent()


      @image  = @element.children(".markregion-image")
      @view   = $('<div class="markregion-view"       />').appendTo(@element)
      @modal  = $("""
        <div id="markregion-modal" class="modal hide fade" tabindex="-1" role="dialog" aria-labelledby="myModalLabel" aria-hidden="true">
          <div class="modal-body">
          </div>
        </div>""").appendTo(@element)

      ###
          <div class="modal-header">
            <button type="button" class="close" data-dismiss="modal" aria-hidden="true">×</button>
            <h3 id="myModalLabel">Editar Marcação</h3>
          </div>
          <div class="modal-footer">
            <button class="btn" data-dismiss="modal" aria-hidden="true">Close</button>
            <button class="btn btn-primary">Save changes</button>
          </div>
      ###

      @edit   = $(""" <div class="markregion-edit">
                        <div class="markregion-edit-area"  />
                      </div>""").appendTo(@element)


      @sizes=
        naturalWidth:   @image[0].naturalWidth
        naturalHeight:  @image[0].naturalHeight
        height: @element.height()
        width: @element.width()


      @element.parent().off ".markregion"

      @element.parent().on("click.markregion", ".markregion", (ev) ->
        if $(ev.target).hasClass("markregion-view")
          parentOffset = $(@).parent().offset();
          # or $(this).offset(); if you really just want the current element's offset
          positions =
            relX : ev.pageX - parentOffset.left
            relY : ev.pageY - parentOffset.top

          size_range = self.sizes.naturalHeight / self.sizes.height

          naturalPositions =
            relX : Math.round positions.relX * size_range
            relY : Math.round positions.relY * size_range

          marcation =
            left: naturalPositions.relX
            top: naturalPositions.relY

          self.renderMarcations marcation, "new"
        ) if @options.editable


      @element.parent().on "mouseenter.markregion", ".markregion", (ev) ->
        $(".markregion-view", ev.delegateTarget).show() if $(".markregion-edit", ev.delegateTarget).css("display") is "none"
      @element.parent().on "mouseleave.markregion", ".markregion", (ev) ->
        $(".markregion-view", ev.delegateTarget).hide()

      @load()
      self


    # Carrega as marcações
    load: ->
      return false unless @options.path
      $.getJSON @options.path.index, (data) =>
        @marcations = data
        @renderMarcations()

    # Renderiza as marcações
    renderMarcations: (marcation, action) ->
      self = @
      marcations = if marcation then [marcation] else @marcations
      action = action || "edit"
      $.each marcations, (i) ->
        marcation = @

        if action is "new"
          params = $.param(marcation: marcation, false)
          path = "#{self.options.path.new}?#{params}"
        else
          path = @path.edit

        # definendo o posicionamento
        @positions= if self.image.length
          left: (@left * self.sizes.width) / self.sizes.naturalWidth
          top: (@top * self.sizes.height) / self.sizes.naturalHeight
        else
          left: @left
          top: @top

        # Caso a marcação já exista remove-la
        exist_marcation = $("#{@id}.markregion-area, .markregion-area.markregion-area-new")
        exist_marcation.remove() if exist_marcation.length

        modal_link = $(if self.options.editable then """<a href="#{path}" role="button" data-target="#markregion-modal" />""" else "<span />")

        modal_link
          .addClass("markregion-modal-link")
          .append("""<i class="icon-search" />""")

        area = $("""
          <div />""")
          .attr("id", @id)
          .addClass("markregion-area #{"markregion-area-new" unless @id}")
          .append(modal_link)
            # <a href="#{@path.edit}" class="markregion-modal-link" role="button" data-toggle="modal" data-target="#markregion-modal"><i class="icon-search" /> </a>
          .appendTo(self.view)
          .css
            left: @positions.left
            top: @positions.top

        link = $("""<div id=\"#{@id}\" class=\"markregion-note\"><a href=\"#{@url || ""}\" target="_blank" >#{@body}</a></div>""")
          .appendTo(area)


        # se for editável, ao clicar no icone cria o form
        modal_link = area.children(".markregion-modal-link").click( (ev) ->
          ev.preventDefault()
          self.formMarcation("#{action}", $(@), marcation)
          ) if self.options.editable

        modal_link.trigger("click") if action is "new" and modal_link.length

        # Execulta o evento de pós criação
        self.element.trigger("markregion-create", marcation)

    # Edição da maracção
    formMarcation: (action, link, marcation) ->
      return false unless marcation
      self = @
      modal = $(link.data("target")).load link.prop("href"), (data) ->
        $this = $(this)

        form = $("form:first", $this).on "submit", (ev) ->
          ev.preventDefault()
          $.ajax
            type: form.attr("method") || "PUT"
            url: form.attr("action")
            data: form.serialize()
            dataType: "json"
          .done (data, status) ->
            self.renderMarcations(data)
            $this.modal("hide")
          # .fail (data, status) ->
          #   console.debug status, data

          $("#markregion-modal").modal("hide");

        $this.modal("show")

        # fixbug firefox focus
        $("input", $this).on "click", ((ev) -> $(this).select() )
      @


  $.fn.markregion = (options) ->
    @each ->
      markregion.init $(this), options

