class MarcationsController < ApplicationController
  before_filter :load_tour
  load_and_authorize_resource
  respond_to :html, :json, :js

  layout :disable_layout_for_xhr

  # GET /marcations
  # GET /marcations.json
  def index
    @marcations = @tour.marcations
    respond_with @marcations
  end

  # GET /marcations/1
  # GET /marcations/1.json
  def show
    @marcation = @tour.marcations.find(params[:id])
    respond_with @marcation
  end

  # GET /marcations/new
  # GET /marcations/new.json
  def new
    @marcation = @tour.marcations.create params[:marcation]
    respond_with @marcation
  end

  # GET /marcations/1/edit
  def edit
    @marcation = @tour.marcations.find(params[:id])
    respond_with @marcation
  end

  # POST /marcations
  # POST /marcations.json
  def create
    @marcation = @tour.marcations.create(params[:marcation])
    # if @marcation.save
    #   flash[:notice] = "Marcation was successfully created."
    # end
    respond_with @marcation
  end

  # PUT /marcations/1
  # PUT /marcations/1.json
  def update
    @marcation = @tour.marcations.find(params[:id])

    if @marcation.update_attributes(params[:marcation])
      flash[:notice] = "Marcation was successfully updated."
    end
    respond_with @marcation
    # respond_with @marcation do |format|
    #   format.json { render json: @marcation }
    # end
  end

  # DELETE /marcations/1
  # DELETE /marcations/1.json
  def destroy
    @marcation = @tour.marcations.find(params[:id])
    @marcation.destroy
    # flash[:notice] = "Marcation was successfully destroyed."
    respond_with @marcation
  end

  private

  def load_tour
    @tour = Tour.find params[:tour_id]
  end

  def disable_layout_for_xhr
    (request.xhr?) ? false : "application"
  end
end
