class Marcation < ActiveRecord::Base
  extend ActiveModel::Naming

  belongs_to :tour
  attr_accessible :body, :left, :top, :url,
    # I18n
    :locale, :translations_attributes

  # Translate
  translates :body, :url
  accepts_nested_attributes_for :translations

  class Translation
    attr_accessible :locale, :body, :url
  end
  def translations_attributes=(attributes)
    new_translations = attributes.values.reduce({}) do |new_values, translation|
      new_values.merge! translation.delete("locale") => translation
    end
    set_translations new_translations
  end


  include Rails.application.routes.url_helpers
  # include ActionView::Helpers::NumberHelper

  def as_json options
    # if can? :update, self
      super.merge!(
        path: {
          show: tour_marcation_path(self.tour, self),
          edit: edit_tour_marcation_path(self.tour, self)
        })
    # else
    #   super
    # end
  end
end
