class CreateTours < ActiveRecord::Migration
  def up
    create_table :tours do |t|
      t.string :slug
      t.string :name
      t.text :body
      t.integer :position
      t.boolean :published, :default => false

      # Options
      t.integer :speed          , :default => 20000
      t.string  :direction      , :default => 'left'
      t.boolean :control_display, :default => true
      t.integer :start_position , :default => 0
      t.boolean :loop           , :default => true
      t.boolean :auto_start     , :default => false

      t.string :tour_file_name
      t.string :tour_content_type
      t.integer :tour_file_size

      t.timestamps
    end

    add_index :tours, :name
    add_index :tours, :slug, :unique => true

    Tour.create_translation_table! :name => :string, :body => :text
  end

  def down
    drop_table :tours
    Tour.drop_translation_table!
  end
end
